Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http
Interface HttpEntity

All Known Subinterfaces:
  ConsumingNHttpEntity, ProducingNHttpEntity

All Known Implementing Classes:
  AbstractHttpEntity, BasicHttpEntity, BufferedHttpEntity, BufferingNHttpEntity, ByteArrayEntity, ConsumingNHttpEntityTemplate, ContentBufferEntity, EntityTemplate, FileEntity, HttpEntityWrapper, InputStreamEntity, NByteArrayEntity, NFileEntity, NHttpEntityWrapper, NStringEntity, SerializableEntity, StringEntity

    public interface HttpEntity

An entity that can be sent or received with an HTTP message. Entities can be found in some `requests` and in `responses`, where they are optional.

There are three distinct types of entities in HttpCore, depending on where their `content` originates:

- streamed: The content is received from a stream, or generated on the fly. In particular, this category includes entities being received from a `connection`. `Streamed` entities are generally not `repeatable`.
- self-contained: The content is in memory or obtained by means that are independent from a connection or other entity. Self-contained entities are generally `repeatable`.
- wrapping: The content is obtained from another entity.

This distinction is important for connection management with incoming entities. For entities that are created by an application and only sent using the HTTP components framework, the difference between streamed and self-contained is of little importance. In that case, it is suggested to consider non-repeatable entities as streamed, and those that are repeatable (without a huge effort) as self-contained.

Since:
  4.0

Method Summary
`void` | `consumeContent()` Deprecated. (4.1) Use `EntityUtils.consume(HttpEntity)`
`InputStream` | `getContent()` Returns a content stream of the entity.
`Header` | `getContentEncoding()` Obtains the Content-Encoding header, if known.
`long` | `getContentLength()` Tells the length of the content, if known.
`Header` | `getContentType()` Obtains the Content-Type header, if known.
`boolean` | `isChunked()` Tells about chunked encoding for this entity.
`boolean` | `isRepeatable()` Tells if the entity is capable of producing its data more than once.
`boolean` | `isStreaming()` Tells whether this entity depends on an underlying stream.
`void` | `writeTo(OutputStream outStream)` Writes the entity content out to the output stream.

Method Detail

### isRepeatable

    boolean isRepeatable()

  Tells if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.

  Returns:
    true if the entity is repeatable, false otherwise.

### isChunked

    boolean isChunked()

  Tells about chunked encoding for this entity. The primary purpose of this method is to indicate whether chunked encoding should be used when the entity is sent. For entities that are received, it can also indicate whether the entity was received with chunked encoding.

  The behavior of wrapping entities is implementation dependent, but should respect the primary purpose.

  Returns:
    `true` if chunked encoding is preferred for this entity, or `false` if it is not

### getContentLength

    long getContentLength()

  Tells the length of the content, if known.

  Returns:
    the number of bytes of the content, or a negative number if unknown. If the content length is known but exceeds `Long.MAX_VALUE`, a negative number is returned.

### getContentType

    Header getContentType()

  Obtains the Content-Type header, if known. This is the header that should be used when sending the entity, or the one that was received with the entity. It can include a charset attribute.

  Returns:
    the Content-Type header for this entity, or `null` if the content type is unknown

### getContentEncoding

    Header getContentEncoding()

  Obtains the Content-Encoding header, if known. This is the header that should be used when sending the entity, or the one that was received with the entity. Wrapping entities that modify the content encoding should adjust this header accordingly.

  Returns:
    the Content-Encoding header for this entity, or `null` if the content encoding is unknown

### getContent

    InputStream getContent()
                           throws IOException,
                                  UnsupportedOperationException

  Returns a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

  IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

  Returns:
    content stream of the entity.
  Throws:
    `IOException` - if the stream could not be created
    `UnsupportedOperationException` - if entity content cannot be represented as `InputStream`.
  See Also:
    `isRepeatable()`

### writeTo

    void writeTo(OutputStream outStream)
                 throws IOException

  Writes the entity content out to the output stream.

  IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated when this method returns.

  Parameters:
    `outStream` - the output stream to write entity content to
  Throws:
    `IOException` - if an I/O error occurs

### isStreaming

    boolean isStreaming()

  Tells whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.

  Returns:
    `true` if the entity content is streamed, `false` otherwise

### consumeContent

    @Deprecated
    void consumeContent()
                        throws IOException

  Deprecated. (4.1) Use `EntityUtils.consume(HttpEntity)`

  This method is deprecated since version 4.1. Please use standard java convention to ensure resource deallocation by calling `InputStream.close()` on the input stream returned by `getContent()`

  This method is called to indicate that the content of this entity is no longer required. All entity implementations are expected to release all allocated resources as a result of this method invocation. Content streaming entities are also expected to dispose of the remaining content, if any. Wrapping entities should delegate this call to the wrapped entity.

  This method is of particular importance for entities being received from a `connection`. The entity needs to be consumed completely in order to re-use the connection with keep-alive.

  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `and #writeTo(OutputStream)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.